
#include <exec/types.h>

struct copData
{
	struct ViewPort *vport;
	WORD sigBit;
	struct Task *sigTask;
};

struct dbufData
{
	struct ScreenBuffer *buffers[2];
	struct MsgPort *safePort;
	BOOL safeToDraw;
	UWORD toggleFrame;
	BOOL held;
};

ULONG bestModeID(WORD width, WORD height, UBYTE depth, STRPTR pubName);
BOOL getDClip(ULONG modeID, struct Rectangle *saveDClip);
struct BitMap *allocBitMap(struct Rectangle *clip, UBYTE depth);
struct Screen *openScreen(ULONG modeID, struct Rectangle *clip, struct BitMap *bm, ULONG tag, ...);
struct Interrupt *attachUserCopList(struct Screen *s, UWORD commands, void (*addCommands)(struct Screen *s, struct UCopList *ucl), BYTE pri);
void detachUserCopList(struct Interrupt *is);
BOOL allocScreenBuffers(struct Screen *s, struct BitMap *bm[2], struct dbufData *dd);
void freeScreenBuffers(struct Screen *s, struct dbufData *dd);
void safeToDraw(struct dbufData *dd, struct RastPort *rp);
BOOL changeScreenBuffer(struct Screen *s, struct dbufData *dd);
